
//=================================================================
#include "main.h"
//=================================================================


void START (void) //
{
	DA_HI;
	CL_HI;
	DA_LOW;
	_delay_us(1); //
	CL_LOW;
}
void STOP (void) //
{
	DA_LOW;
	CL_HI;
	_delay_us(1); //
	DA_HI;
}
void SEND (unsigned char data) //   
{
	unsigned char k;

	for(k=8;k>0;k--)
	{
		if(data&(1<<(k-1)))
		{
			CL_LOW;
			DA_HI;
			_delay_us(1); //
			CL_HI;
			_delay_us(1); //
			CL_LOW;
		}
		else
		{
			CL_LOW;
			DA_LOW;
			_delay_us(1); //
			CL_HI;
			_delay_us(1); //
			CL_LOW;
		}
	}
	_delay_us(1); //
	//ACK
	DA_HI;
    _delay_us(1); //
	CL_HI;
	_delay_us(1); //
	if(!(PINC&(1<<4)))
	CL_LOW;
	_delay_us(3); //
}
void OLED_INIT (void)  // 
{
	unsigned char k;

	START();
	SEND(NAME);

	for(k=0;k<18;k++)
	{
		SEND(COM);
		SEND(pgm_read_byte(init+k));
	}

	STOP();
} 
void CLR_SCR (void) //  
{
	unsigned char k, kk;

	START();
	SEND(NAME);

	// Horizontal Addressing Mode (       )
	SEND(COM);
	SEND(0x20);
	SEND(COM);
	SEND(0x00);

	//   
	SEND(DATS);
	for(kk=0;kk<8;kk++)
	{
		for(k=0;k<128;k++) SEND(0x00);	//LSB , MSB 
	}

	STOP();
}

void migalka (void) 
{
	
	for (unsigned int i =0; i<3; i++)
	{	
	PORTB |= (1<<i);
	_delay_ms(500);
	PORTB &= ~(1<<i);		
	}

} 

int main(void)
{
		
DDRB = 0b00000111;
PORTB = 0b00000000;

migalka(); //     
	
 while(1)
 {

 unsigned int k;
 unsigned char kk;


 // 	CLKPR=0x80;
 // 	CLKPR=0x00;	// ,   8 MHz

 PORTC=0x00;	//C5  SCK, C4  SDA
 DDRC =0x00;

 // 	PORTD=0b00100000;	//   ,   
 // 	DDRD =0b01000000;	//   ,   
 //
 // 	PORTB=0x00;		//  
 // 	DDRB =0x00;		//  
 //
 // 	ACSR=0x80;		//     

 _delay_ms(500);	//   -      

 OLED_INIT();	// 
 CLR_SCR();		//  


 		// 
 		START();
 		SEND(NAME);		// +0

 		SEND(DATS);
 		for(k=0;k<1024;k++) SEND(pgm_read_byte(screen_1+k));

 		STOP();




 		_delay_ms(2000);

  while(1)
  {
  //-------------------------------------------------------------------------
  PORTB |= (1<<0); //    PB0   
  _delay_ms(500);
  PORTB &= ~(1<<0);
  _delay_ms(500);
  //--------------------------------------------------------------------------
	  for(kk=0;kk<5;kk++)
	  {
		  START();
		  SEND(NAME);
		  
		  SEND(COM);
		  SEND(0x21);		//Set Column Address (21h)
		  SEND(COM);
		  SEND(115);		//   115...
		  SEND(COM);
		  SEND(126);		//... 126 

		  SEND(COM);
		  SEND(0x22);		//Set Page Address (22h)
		  SEND(COM);
		  SEND(6);		//   6-...
		  SEND(COM);
		  SEND(7);		//... 7-  ()

		  SEND(DATS);
		  for(k=0;k<12;k++) SEND(pgm_read_byte(DIGIT[kk]+k));		//   
		  for(k=12;k<24;k++) SEND(pgm_read_byte(DIGIT[kk]+k));	//   
		  
		  STOP();
		  _delay_ms(1000);
	  }
  }

 //--------------------------------------------------------------							
 }	
}

